<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.accessfacepushrecords_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/estate/accessfacepushrecords";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "主键Id",
              prop: "lId",
              rules: [{
                required: true,
                message: "请输入主键Id",
                trigger: "blur"
              }]
            },
            {
              label: "用户类型	住户：1，	服务人员：2",
              prop: "iAccessUserType",
              rules: [{
                required: true,
                message: "请输入用户类型	住户：1，	服务人员：2",
                trigger: "blur"
              }]
            },
            {
              label: "设备id",
              prop: "lDeviceId",
              rules: [{
                required: true,
                message: "请输入设备id",
                trigger: "blur"
              }]
            },
            {
              label: "用户id",
              prop: "lUserId",
              rules: [{
                required: true,
                message: "请输入用户id",
                trigger: "blur"
              }]
            },
            {
              label: "下发人脸照片",
              prop: "sFaceUri",
              rules: [{
                required: true,
                message: "请输入下发人脸照片",
                trigger: "blur"
              }]
            },
            {
              label: "人脸有效开始时间",
              prop: "tBeginDate",
              rules: [{
                required: true,
                message: "请输入人脸有效开始时间",
                trigger: "blur"
              }]
            },
            {
              label: "人脸有效结束时间",
              prop: "tEndDate",
              rules: [{
                required: true,
                message: "请输入人脸有效结束时间",
                trigger: "blur"
              }]
            },
            {
              label: "下发时间",
              prop: "tAccessDate",
              rules: [{
                required: true,
                message: "请输入下发时间",
                trigger: "blur"
              }]
            },
            {
              label: "人脸启用状态标记：{1：已启用，2：已禁用 }",
              prop: "iEnable",
              rules: [{
                required: true,
                message: "请输入人脸启用状态标记：{1：已启用，2：已禁用 }",
                trigger: "blur"
              }]
            },
            {
              label: "创建时间",
              prop: "tCreateDate",
              rules: [{
                required: true,
                message: "请输入创建时间",
                trigger: "blur"
              }]
            },
            {
              label: "下发到的设备类型：{1：一般设备，2：特殊设备}",
              prop: "iSendDeviceType",
              rules: [{
                required: true,
                message: "请输入下发到的设备类型：{1：一般设备，2：特殊设备}",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.accessfacepushrecords_add, false),
          viewBtn: this.vaildData(this.permission.accessfacepushrecords_view, false),
          delBtn: this.vaildData(this.permission.accessfacepushrecords_delete, false),
          editBtn: this.vaildData(this.permission.accessfacepushrecords_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
